/*.A. Alberti, S. Baldan, P. Pasteris
  Progetto multimediale, Comunicazione digitale, 
  Università degli Studi di Milano 14/15
  Composizione di immagine con chiave cromatica in tempo reale
*/
import codeanticode.gsvideo.*;
import java.awt.Color;

GSCapture cam;
PImage back, front;
float targetHue;
float Htollerance,
      Stollerance,
      Btollerance;

void setup() {
   int w, h;
   w = 320; h = 240;
   size(w, h);
   cam = new GSCapture(this, w, h); //init del canale video
   cam.start();  // inizia il processo di cattura del video
   back= loadImage("back.jpg");
   front= loadImage("front.png");
   targetHue=134f/360f; //cerchiamo la chiave cromatica verde
   Htollerance=0.2f;
   Stollerance=0.3f;
   Btollerance=0.3f;
}

void draw() {
    if (cam.available()) {
        image(back,0,0);            //visualizza sfondo
        cam.read();                 //cattura img da camera
        image(chromaKey(cam),0,0);  //visualizza img catturata 'bucata'
        image(front,0,0);           //sovraimponi img frontale  
    }
}

PImage chromaKey(PImage layer){
  int dimension = layer.width*layer.height;
  float[] hsb =  new float[3];
  float deltaHue, alpha_channel;
  PImage alphaImage = createImage(layer.width,layer.height,ARGB); 
  //init array pixels[] per img layer e alphaImage
  layer.loadPixels();
  alphaImage.loadPixels();
  
  //per ogni pixel dell'img layer catturata dalla cam
  for(int i=0;i<dimension;i++){
    //conversione dallo spazio colore RGB allo spazio HSB
    Color.RGBtoHSB((int)red(layer.pixels[i]),(int)green(layer.pixels[i]),(int)blue(layer.pixels[i]), hsb);
    //differenza di tonalità tra la tonalità cercata e quella corrente
    deltaHue = Math.abs(hsb[0]-targetHue);
    if(deltaHue < Htollerance && hsb[1]> Stollerance && hsb[2]> Btollerance){
      alpha_channel=0;  //è un pixel trasparente del fondale in chiave cromatica    
    }else{
      alpha_channel=1;  //è un pixel opaco dell'immagine layer da tenere
    }   
    alphaImage.pixels[i]=color(red(layer.pixels[i]),green(layer.pixels[i]),blue(layer.pixels[i]),alpha_channel*255);
  }
  //chiamare sempre loadPixel prima e updatePixel dopo manipolazioni di pixel
  alphaImage.updatePixels();
  //alphaImage.resize(layer.width/2,layer.height/2);
  return alphaImage;
}
